#!/bin/sh 
#
# Usage: deletefilter [-v] device rootHandle parentHandle classHandle addr
#
# Remove a specific filter
#
# Note: this script is CBQ protocol dependent
#
# Author:  Marc Siriratsivawong
# Version: $Revision: 1.2 $, $Date: 2001/08/17 15:26:40 $

TC=TC_DIR/tc
AWK=/bin/awk
GREP="/bin/grep -w"
ECHO=/bin/echo

echo Content-type: text/plain
echo

usage() {
    echo "usage: $0 [-v] -dev device -rhdl rootHandle "
    echo "               -phdl parentHandle -chdl classHandle "
    echo "               -addr address"
    echo ""
}

case $1 in
-hv|-h|-vh) usage ; exit 1 ;;
-v*) VERBOSE=1 ; echo Verbose ON ; shift  ;;
*)  VERBOSE=0 ;;
esac

############ parse command line parameters ############

case $# in
0) echo ERROR ; usage ; exit 1;;
10)
	while [ $# -gt 0 ] 
	    do
		case $1 in
		    -dev)  DEVICE=$2       ;;
		    -rhdl) ROOTHANDLE=$2   ;; #root handle
		    -phdl) PARHANDLE=$2    ;; #Parent Handle
                    -chdl) CLSHANDLE=$2    ;; #class handle
                    -addr) ADDR=$2         ;; #filter address
                    *) echo ERROR wrong argument $1 ; exit 1;;
		esac
		shift 2
	    done ;;

*) echo ERROR ; usage ; exit 1;;
esac

CHDL="$ROOTHANDLE":"$CLSHANDLE"

FHDL=`$TC filter ls dev $DEVICE | grep $CHDL | grep $ADDR | awk '{print $10}'`
PRIO=`$TC filter ls dev $DEVICE | grep $CHDL | grep $ADDR | awk '{print $7}'`

RET=`$TC filter del dev $DEVICE  protocol ip prio $PRIO parent $ROOTHANDLE: handle $FHDL u32 2>&1` 

if [ -n "$RET" ] ; then
    echo ERROR $DEVICE cannot delete filter
    exit 1
fi

echo
echo SUCCESS $DEVICE $ROOTHANDLE $PARHANDLE $CLSHANDLE

exit

#
# $Log: deletefilter.cgi,v $
# Revision 1.2  2001/08/17 15:26:40  jfhuard
# removed hardcoded path for tc
#
# Revision 1.1  2001/08/17 15:06:09  marcs
# *** empty log message ***
#
#
#