#!/bin/sh 
USAGE="usage: $0 [-hv] -dev device"
#
# Make an allocation by src/dst IP, by attaching filter to ingress 
# qdisc parent.
#
# Author:  nemo@invisiblehand.net
# Version: $Revision: 1.1 $, $Date: 2005/01/03 10:19:02 $
# $Id: unalloc-ingress.cgi,v 1.1 2005/01/03 10:19:02 nemo Exp $

source routux.conf

echo Content-type: text/plain
echo

usage() {
    echo "usage: $0 [-v] -dev device -flowid flowid "
    echo ""
}

case $1 in
-hv|-h|-vh) usage ; exit 1 ;;
-v*) VERBOSE=1 ; echo Verbose ON ; shift  ;;
*)  VERBOSE=0 ;;
esac

############ parse command line parameters ############

case $# in
0) echo ERROR ; usage ; exit 1;;
4)
	while [ $# -gt 0 ] 
	    do
		case $1 in
		    -dev)  DEVICE=$2       ;;
                    -flowid) FLOWID=$2    ;; 
                    *) echo ERROR wrong argument $1 ; exit 1;;
		esac
		shift 2
	    done ;;

*)  echo ERROR ; usage ; exit 1;;
esac

if [ $VERBOSE -eq 1 ]; then 
    echo interface:     $DEVICE
    echo flowid:        $FLOWID
    echo 
fi

# ingress qdisc is classless, parent is always ffff:
# do show for filters with that parent, and parse lines like:
#filter protocol ip pref 100 u32 fh 800::801 order 2049 key ht 800 bkt 0 flowid :1 

FLOWID_STR="flowid :"$FLOWID

if [ $VERBOSE -eq 1 ]; then 
   echo $FLOWID_STR
fi

PRIO=`$TC filter show dev $DEVICE parent ffff: | grep "$FLOWID_STR" | \
	awk '{if(!foundflow) {print $5; foundflow=1}}'`
FHDL=`$TC filter show dev $DEVICE parent ffff: | grep "$FLOWID_STR" | \
	awk '{if(!foundflow) {print $8; foundflow=1}}'`

if [ $VERBOSE -eq 1 ]; then 
    echo prio:     $PRIO
    echo fhdl:     $FHDL
fi

RET=`$TC filter del dev $DEVICE protocol ip prio $PRIO parent ffff: handle $FHDL u32 2>&1`

if [ -n "$RET" ] ; then
    echo ERROR $DEVICE cannot delete filter: $RET
    exit 1
fi

echo SUCCESS $DEVICE flowid=$FLOWID handle=$FHDL prio=$PRIO
    
exit
